
#include "end.h"
#include "../ParticleEngine.h"

extern ParticleEngine pe;
Vector *p;
const int taloja=16;

void drawBuilding(Vector v) {
	
	// katto
	glVertex3f(v.x,v.y,v.z);
	glVertex3f(v.x+1,v.y,v.z);
	
	glVertex3f(v.x+1,v.y,v.z);
	glVertex3f(v.x+1,v.y,v.z+1);
	
	glVertex3f(v.x+1,v.y,v.z+1);
	glVertex3f(v.x,	 v.y,v.z+1);

	glVertex3f(v.x,	 v.y,v.z+1);
	glVertex3f(v.x,	 v.y,v.z);

	//seint
	glVertex3f(v.x,v.y,v.z);
	glVertex3f(v.x,  0,v.z);
	
	glVertex3f(v.x+1,v.y,v.z);
	glVertex3f(v.x+1,  0,v.z);
	
	glVertex3f(v.x+1, v.y,v.z+1);
	glVertex3f(v.x+1,   0,v.z+1);

	glVertex3f(v.x,	 v.y,v.z+1);
	glVertex3f(v.x,	 0,v.z+1);
	
}

Vector *p2;
Vector *p2spd;
const int part_n = 5;
/*
void run(Vector &v, Vector &spd) {

	float dist;
	dist = v.length();

	Vector u = v.normalize();

	spd -= u / ( dist * dist );

	v   -= spd/100.0f;

}


void end2(float aika) {

	float bgalpha;
	bgalpha = calcPosFloat(aika,0.0f,0.15f)-calcPosFloat(aika,0.75f,0.80f);

/*			glLoadIdentity();

			glEnable(GL_BLEND);
			glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);

			// Tausta efekti!


				glEnable(GL_TEXTURE_2D);
				glDisable(GL_DEPTH_TEST);
				glBindTexture(GL_TEXTURE_2D, pillars_texture->ID);
				glColor4f(0.15f*bgalpha,0.15f*bgalpha,0.25f*bgalpha, bgalpha/3.0f );
			
				glPushMatrix();

				// Tt voidaan siirt beateill!
				//glLoadIdentity();
				perspective2D(1,1);
				
				//glRotatef(aika*350,-0.2f,0.4f,1);
				float m = (((float)originalaika/400.0f)+1)*5.0f;
				billboard(
					Vector(aika,0,0) ,	//
						//Vector(calcPosFloat(aika,0.0f,0.5f)*6, 0.3f,-50), 

						Vector(1,0,0),
						Vector(0,1,0),
						Vector(0,0,1),
						(8-6*calcPosFloat(aika,0,0.3f))*1.0f	// isona ettei ny reunukset yms.
						);

				glDisable(GL_TEXTURE_2D);
				
				perspective3D();
				glPopMatrix();

			int i;
			glDisable(GL_DEPTH_TEST);
			
			glTranslatef(0,0,-5-calcPosFloat(aika,0.3f,1)*30);
			glEnable(GL_BLEND);
			//glBlendFunc(GL_ZERO,GL_ONE_MINUS_SRC_ALPHA);
			glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA);
			const char *text[2] = 
			{ 
			  
			  "          TRACTION             ",
			  "            INDIGO             ",

			};

			float last_t=1.0f;
		
			for(i=0; i<2; i++)  {
		
				last_t = calcPosFloat(aika, 0.25f+i*0.10f, 0.25f+i*0.16f)
						 - calcPosFloat(aika,0.95f, 1.0f);
				
				//glColor4f(last_t*0.3f,0.2f*last_t,last_t*0.8f, last_t);
				glColor4f(0.3f*bgalpha,0.3f*bgalpha,0.5f*bgalpha,1*bgalpha);

				glPushMatrix();
				
				glTranslatef(-4.1f,i*-2.0f+0.6f ,-5);
				
				font_write3d(text[i]); 
	 
				glPopMatrix();
			}

}

void end(float aika) {

	float toy = 0.0f;
	//toy += p[0].y - 4.0f;
	gluLookAt(	 0, 13+toy,-10,
				 0,  5+toy,  0,
				 0,	    1,   0);

	int i;
	glLineWidth(1.0f);
	glBegin(GL_LINES);
	for(i=0; i<taloja; i++) {
		
		p[i].y = calcPosFloat(aika, 0, 0.3f)*4.0f*(i/5.0f);
		
		drawBuilding(p[i]);

	}
	glEnd();

// FORCE



//	pe.addEffect(0,0,0,10); 
//	glRotatef(aika*3600,0,0,1);
//	pe.draw();

}
*/

void end_init() {
	int i;
	
	p2 = new Vector[part_n];
	p2spd = new Vector[part_n];
	for(i=0; i<part_n; i++) {
		p2[i] = Vector(randFloat()*5.0f, randFloat()*5.0f, randFloat()*5.0f);
		p2spd[i] = Vector(randFloat()*6.0f, randFloat()*6.0f, randFloat()*6.0f);
	}

	p = new Vector[16];
	
	
	for(i=0; i<taloja; i++) 
		p[i] = Vector(3*(i/4.0f), randFloat()*2.0f+6.0f, 3*(i%4));

}

void end_free() {
	delete [] p;	
	delete [] p2;
	delete [] p2spd;
}
 
