#include "pillars.hpp"
#include "../stuff.hpp"

Vector *pillar;
const int numpil = 48;
Vector *pillartop;
const int numptop = 8;

const bool ar[11][10] = { 
{0,0,0,0,0,0,0,0,0,0},
{0,0,0,1,1,1,1,0,0,0},
{0,0,1,1,1,1,1,1,0,0},
{0,1,1,1,1,1,1,1,1,0},
{0,1,1,1,1,1,1,1,1,0},
{0,1,1,0,1,1,1,1,1,0},
{0,0,1,1,0,1,1,1,0,0},
{0,0,0,1,1,1,1,0,0,0},
{0,0,0,0,1,0,0,0,0,0},
{0,0,0,0,0,1,1,0,0,0},
{0,0,0,0,0,0,0,0,0,0}
};

void pillars(float aika) {
	int i,n,m;
		
	const int height = 10;

	// CREATE THE PILLAR
	float ker = height/(numpil/4);
	float h=0;
	for(i=0; i<numpil; i+=4) {
		h=(float) i*1;
		pillar[i].x=0;
		pillar[i].y=h;
		pillar[i].z=0;
		
		pillar[i+1].x=10;
		pillar[i+1].y=h;
		pillar[i+1].z=0;

		pillar[i+2].x=10;
		pillar[i+2].y=h;
		pillar[i+2].z=10;

 		pillar[i+3].x=0;
		pillar[i+3].y=h;
		pillar[i+3].z=10;

	}
		i=0;
		pillartop[i].x=0;
		pillartop[i].y=h;
		pillartop[i].z=0;

		pillartop[i+1].x=10;
		pillartop[i+1].y=h;
		pillartop[i+1].z=0;

		pillartop[i+2].x=10;
		pillartop[i+2].y=h;
		pillartop[i+2].z=10;

		pillartop[i+3].x=0;
		pillartop[i+3].y=h;
		pillartop[i+3].z=10;

		pillartop[i+4].x=0;
		pillartop[i+4].y=h+2+sin((float)aika*24)*10+10;
		pillartop[i+4].z=0;

		pillartop[i+5].x=10;
		pillartop[i+5].y=h+2+sin((float)aika*24)*10+10;
		pillartop[i+5].z=0;

		pillartop[i+6].x=10;
		pillartop[i+6].y=h+2+sin((float)aika*24)*10+10;
		pillartop[i+6].z=10;

		pillartop[i+7].x=0;
		pillartop[i+7].y=h+2+cos((float)aika*24)*10+10;
		pillartop[i+7].z=10;


	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();

	gluLookAt(cos((float)aika*48)*45.0f, 150, sin((float)aika*24)*45.0f, 
				0,0,-80, 
				0,1,0);
 

	glDisable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glEnable(GL_DEPTH_TEST);

	
	glTranslatef(-75,-75,-20);
	
	glScalef(1+50*calcPosFloat(aika,0.5f,0.9f),1,1+50*calcPosFloat(aika,0.5f,0.9f));

	if(aika<0.9)
	for(m=0; m<calcPosFloat(aika+0.07f,0,0.5f)*11; m++) {
	  for(n=0; n<calcPosFloat(aika+0.05f,0,0.5f)*10; n++) {

	 glTranslatef(15,0,0);


		glBegin(GL_QUADS);
		glColor4f(0,0.2f-0.2f*calcPosFloat(aika,0.3f,0.5f),0,0.2f);
		for(i=0; i<numpil; i++) {
			if(i!=3) {
			 glVertex3fv((float *)&(pillar[i%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+1)%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+5)%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+4)%numpil]) );
			} else {
			 glVertex3fv((float *)&(pillar[i%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+5)%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+1)%numpil]) );
			 glVertex3fv((float *)&(pillar[(i+4)%numpil]) );
			}

		}

	    /*
		// Nostaa tolppia
		pillartop[7].y+=(m+n)%2;
		pillartop[6].y+=(m+n)%2;
		pillartop[5].y+=(m+n)%2;
		pillartop[4].y+=(m+n)%2;
		*/


		for(i=0; i<4; i++) {
			if(i!=3) {
				glColor4f(0,0.2f,0,0.2f);			
				glVertex3fv((float *)&(pillartop[i%8]) );
				glColor4f(0,0.2f,0,0.2f);			
				glVertex3fv((float *)&(pillartop[(i+1)%8]) );
				glColor4f(0,0.4f,0,0.2f);
				glVertex3fv((float *)&(pillartop[(i+5)%8])  );
				glColor4f(0,0.4f,0,0.2f);
				glVertex3fv((float *)&(pillartop[(i+4)%8]) );
			} else {
				glColor4f(0,0.2f,0,0.2f);			
				glVertex3fv((float *)&(pillartop[i%8]) );
				glColor4f(0,0.2f,0,0.2f);
				glVertex3fv((float *)&(pillartop[(i+5)%8])  );
				glColor4f(0,0.4f,0,0.2f);			
				glVertex3fv((float *)&(pillartop[(i+1)%8]) );
				glColor4f(0,0.4f,0,0.2f);
				glVertex3fv((float *)&(pillartop[(i+4)%8]) );
			}
		}

		
		glColor3f(0.0,0.0,0.3f);
			if(!ar[m][n]) glColor4f(0,calcPosFloat(pillartop[4].y,40,90),0,0.2f);
			glVertex3fv((float *)&(pillartop[4]) );

			if(!ar[m][n]) glColor4f(0,calcPosFloat(pillartop[5].y,40,90),0,0.2f);
			glVertex3fv((float *)&(pillartop[5]) );

			if(!ar[m][n]) glColor4f(0,calcPosFloat(pillartop[6].y,40,90),0,0.2f);
			glVertex3fv((float *)&(pillartop[6]) );

			if(!ar[m][n]) glColor4f(0,calcPosFloat(pillartop[7].y,40,90),0,0.2f);
			glVertex3fv((float *)&(pillartop[7]) );
			
		glEnd();
	
	}
	glTranslatef((float)-15*n ,0,-15);	
   }
}

void pillars_init() {
	pillar = new Vector[numpil];
	pillartop = new Vector[8];	

}

void pillars_free() {
	delete [] pillar;
	delete [] pillartop;
}
 
