#include "sawart.h"

// aajoo taskin sqrt:)
// ok eli nyt pitas olla sit iha ok
//#include "../ParticleEngine.h"

//extern ParticleEngine pe;

extern bool beat_handled;
extern int last_beat;

Vector par;
// 100x100

class FieldLine {
public:
	FieldLine()  { force=Vector(); 
			       position=Vector();
			       alpha=1.0;
				   len=0;
				 } 
	float alpha;
	float len;
	Vector position;	// position of the base Parti
	Vector force;		// destination of the push
};

const int fieldlines = 25;
const int total_fieldlines = fieldlines*fieldlines*fieldlines;
FieldLine *flines;
Vector cam_pos;

class Charge {
public:
	Charge()  { position=Vector(); 
				velocity=Vector();
			 } 
	Vector position;		// position of the base Parti
	Vector velocity;		// destination of the push

	
	void tick(int i, float aika) {

		  Vector distance = this->position - flines[i].position;
		  float dist = distance.length();
		   
		  if(dist<15.0f - calcPosFloat(aika,0.2f,0.3f)*10 ) {
						
					Vector force;	
				    Vector r = distance.normalize();

					// (dL x 'r)/r^2
					force = (this->velocity).crossProduct( r );

					float r2 = distance.length();
		
					flines[i].force+=force/(r2*r2);

					flines[i].len=flines[i].force.length();
					
					if(dist<1.5f) 
						if(flines[i].alpha > 0.0f)
							flines[i].alpha-=0.2f;
			 	}

	}
};

float bga;


Charge *charges;
const int num_charges=5;

// aika: 95000 - 130500
const int saw_sync_num=11;
Sync sawsyncs[saw_sync_num] = 
{
	Sync( 93000, 94000),
	Sync( 96500, 97500),
	Sync(100000,101000),
	Sync(103500,104500),
	Sync(107000,108000),
	Sync(111000,112000),
//	Sync(114200,115200),	// POIS uudessa versiossa
	Sync(117800,118800),	// 120 = 2min
	Sync(121700,122700),
	Sync(125000,126000),	
	Sync(128700,129700),	
	Sync(132000,132800),	// viimenen hiukan lyhyempi 
};

// Multiply charges
const int saw_sync_mult = 5;

Sync saw2beep(172300, 173800);


void saw(float aika) {
	
    glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	
		// Tausta efekti!
		bga = 0.5f*(calcPosFloat(aika,0.0f,0.05f)-calcPosFloat(aika,0.85f,1.0f));

		glEnable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glBindTexture(GL_TEXTURE_2D, box_texture->ID);
		glColor4f(0.05f*bga,0.05f*bga,0.3f*bga, bga/4.0f );
	
		glPushMatrix();

		glLoadIdentity();
		perspective2D(1,1);
		
		glRotatef(aika*-350,0,0,0.6f);
		billboard(Vector() ,
				Vector(1,0,0),
				Vector(0,1,0),
				Vector(0,0,1),
				(8-5*calcPosFloat(aika,0,0.3f))*0.8f	// isona ettei ny reunukset yms.
				);

		glDisable(GL_TEXTURE_2D);
		
		perspective3D();
		glPopMatrix();


	int i;

	glLoadIdentity();

	float sini = sin(aika*25);
	gluLookAt(
		cam_pos.x,
		cam_pos.y,
		cam_pos.z,
		
		sini*2,
		sini*2,
		sini*2,	
	
		0,1,0);
	
	// BEATS

	if(!beat_handled) {
		last_beat = originalaika;
	}
	const int beatinterval=300;
	
	float alpha = (1-calcPosInt(originalaika, last_beat, last_beat+300))*0.1f;

	float alpha2 = alpha*4.0f + 0.3f;

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	
	glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA); // ALPHA blend bitplanes

	float n= 1
		//-calcPosFloat(aika,0.29f,0.3f)+
		//	 calcPosFloat(aika,0.3f,0.33f)
			 -calcPosFloat(aika,0.98f,1.0f);

	glScalef(n,n,n);
		
	glLineWidth(1.0f);

	if(aika<0.3f)
		glRotatef(aika*1200.0f,-1,0,0);

	 glBegin(GL_LINES);

		for(i=0; i<total_fieldlines; i++) {
			
				glColor4f(	0.6f*flines[i].alpha*bga*alpha2,
							0.6f*flines[i].alpha*bga*alpha2,
							0.9f*flines[i].alpha*bga*alpha2,
							0.6f*flines[i].alpha*bga*alpha2);

						if( flines[i].force.x!=0 && 
							flines[i].force.y!=0 && 
							flines[i].force.z!=0) {

							glVertex3fv((float *)(& flines[i].position));
							glColor4f(0.3f*flines[i].alpha*bga*alpha2,
								  	  0.5f*flines[i].alpha*bga*alpha2,
 					  				  0.9f*flines[i].alpha*bga*alpha2,
									  0.6f*flines[i].alpha*bga*alpha2
									  );

							glVertex3fv((float *)&(flines[i].position+(flines[i].force*4)));	
						}
			 
			  if(flines[i].alpha<1.0f)
				  flines[i].alpha+=0.1f;

			  flines[i].force = Vector(0,0,0);
			  
			  for(int n=0; n<num_charges; n++) {
				  charges[n].tick(i, aika);
		/*		
				if( originalaika > sawsyncs[saw_sync_mult].starttime ) {
				
					  for(int g=0; g<2; g++) {
 					   Charge chg = charges[n];
					   chg.position.x+=100;
					   charges[n].tick(i, aika);
					  }
				  }
		*/
			  }

		}
	
	 glEnd();

	int k;
	float kerroin=1.0f;

	for(k=0; k<saw_sync_num; k++)
		if(originalaika>sawsyncs[k].starttime) {

			if(sawsyncs[k].getVal(originalaika)<1.0f)
		     kerroin+=0.5f*(1-sawsyncs[k].getVal(originalaika));

		}

	cam_pos = sphereCoord(((1-calcPosFloat(aika,0,0.15f))*20.0f+
								   (1-calcPosFloat(aika,0,0.45f))*15.0f+
								   25.0f), 
						  kerroin*aika*14.0f, 
						  aika*22.0f);

	int l;
	for(l=0; l<num_charges; l++) {


		if( originalaika > sawsyncs[saw_sync_mult+3].starttime ) {

		 charges[l].position.x = sin(aika*l*36)*3*l-5;
		 charges[l].position.y = cos(aika*l*60)*l*0.5f+(l*3);
		 charges[l].position.z = cos(aika*40*l)*l*2.0f+1;
		
		} else
		if( originalaika > sawsyncs[saw_sync_mult+2].starttime ) {

		 //charges[l].position.x = sin(aika*36)*2+l;
		 charges[l].position.y = cos(aika*40*l)*1.5f;
		 charges[l].position.z = cos(aika*50*l)*1.5f;

		} else 
		if( originalaika > sawsyncs[saw_sync_mult+1].starttime ) {

		 charges[l].velocity.x=0.0f;
		 charges[l].velocity.y=1.5f;
		 charges[l].velocity.z=1.5f;
	
		 charges[l].position.x = 0;
		 charges[l].position.y = cos(aika*60)*4+l*2.6f;;
		 charges[l].position.z = sin(aika*75)*6+l*2.6f;

		} else if( originalaika > sawsyncs[saw_sync_mult].starttime ) {
		 
		 charges[l].position.x = l*0.1f;
		 charges[l].position.y = l*0.1f;
		 charges[l].position.z = 0;
		
		} else {
		 charges[l].position.x = sin(aika*26)*3+l-5;
		 charges[l].position.y = cos(aika*20*l)*1.5f;
		}

	}

	if( originalaika < sawsyncs[saw_sync_mult].starttime ) { 

		// Lame optimization
		float sin25 = sin(aika*25)*16;

		charges[1].position.y  =  sin25;
		charges[2].position.x  =  sin25;
		charges[2].position.z  =  sin25/4.0f;
		charges[3].position.z  =  sin25;
		charges[4].position.y  =  sin(aika*45)*8;

	}
	float m = 0;
	float y = 0;
	
	if(aika>0.35f) {
		
		bga=calcPosFloat(aika,0.35f,0.4f);

		m = (((float)originalaika/400.0f)+1)*5.0f;
		y = aika*65.0f;
	
		
		filter.draw_grid(pillars_texture, 
			bga*alpha*0.5f
			, -m, 0, 1.0f, 1.0f, 1.0f, 3.6f, 0);

		filter.draw_grid(box_texture, 
			bga*alpha*1.5f
			, -y, 0, 0.5f, 0.5f, 1.0f, 0.2f, 0 );
	}

}

void saw_init() {

	last_beat=0;
	charges = new Charge[num_charges];

	for(int n=0; n<num_charges; n++) 
		charges[n].velocity.x=1.5f;
		
	charges[0].position.z=8.0f;
	charges[1].position.z=-3.0f;
	charges[2].position.y=5.0f;
	charges[3].position.z=-4.0f;
	charges[4].position.z=8.0f;

	charges[0].velocity.x=1.5f;
	charges[1].velocity.y=1.5f;
	charges[2].velocity.z=1.5f;
	charges[3].velocity.x=1.5f;
	charges[4].velocity.y=1.5f;

	flines = new FieldLine[total_fieldlines];
	
	int x,y,z,i=0;
	Vector tmp(0,10,0);

	for(x=0; x<fieldlines; x++) 
		for(y=0; y<fieldlines; y++) 
			for(z=0; z<fieldlines; z++) 
			{
				flines[i].position.x = x-fieldlines/2.0f;
				flines[i].position.y = y-fieldlines/2.0f;
				flines[i].position.z = z-fieldlines/2.0f;


				flines[i].force = flines[i].position;

				i++;
			}

	cam_pos=Vector();
	par = Vector();
}

void saw_free() {
	delete [] flines;	
	delete [] charges;
}

void saw2(float aika) {

	
    glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	
		// Tausta efekti!
		bga = 0.5f*(calcPosFloat(aika,0.0f,0.05f)-calcPosFloat(aika,0.85f,1.0f));

		glEnable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glBindTexture(GL_TEXTURE_2D, circle3_texture->ID);
		glColor4f(0.05f*bga,0.05f*bga,0.3f*bga, bga/4.0f );
	
		glPushMatrix();

		glLoadIdentity();
		perspective2D(1,1);
		
		glRotatef(aika*-350,0,0,0.6f);
		billboard(Vector() ,
				Vector(1,0,0),
				Vector(0,1,0),
				Vector(0,0,1),
				(8-5*calcPosFloat(aika,0,0.3f))*0.8f	// isona ettei ny reunukset yms.
				);

		glDisable(GL_TEXTURE_2D);
		
		perspective3D();
		glPopMatrix();


	int i;

	glLoadIdentity();

	gluLookAt(
		cam_pos.x,
		cam_pos.y,
		cam_pos.z,
		0,0,0,
		0,1,0);
	
	if(!beat_handled) {
		last_beat = originalaika;
	}
	const int beatinterval=300;
	
	float alpha = (float)(1-calcPosInt(originalaika, last_beat, last_beat+300))*0.1f;

	glDisable(GL_DEPTH_TEST);
	glEnable(GL_BLEND);
	
	//glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA); // ALPHA blend bitplanes
	glBlendFunc(GL_ONE,GL_ONE_MINUS_SRC_ALPHA); // ALPHA blend bitplanes

	float n= 1-calcPosFloat(aika,0.98f,1.0f);

	glScalef(n,n,n);
		
	glLineWidth(3.0f);

	if(aika<0.3f)
		glRotatef(aika*1200.0f,-1,0,0);

		for(i=0; i<total_fieldlines; i++) {
			
			if(i%3==0) {


			if(abs(flines[i].force.x)>0.10f && 
			   abs(flines[i].force.y)>0.10f && 
			   abs(flines[i].force.z)>0.10f)

				glColor4f(	0.9f*flines[i].alpha*bga,
							0.3f*flines[i].alpha*bga,
							0.3f*flines[i].alpha*bga,
							0.9f*flines[i].alpha*bga);
			else 
	 		    glColor4f(	0.65f*((aika+0.4f)/2.0f+0.25f)*flines[i].alpha*bga,
							0.65f*((aika+0.4f)/2.0f+0.25f)*flines[i].alpha*bga,
							0.95f*flines[i].alpha*bga,
							0.9f*flines[i].alpha*bga);




						glEnable(GL_TEXTURE_2D);
						if(i%6==0)
								glBindTexture(GL_TEXTURE_2D, circle3_texture->ID);
						else 
								glBindTexture(GL_TEXTURE_2D, particle_texture->ID);

								billboard(flines[i].position+(flines[i].force*3),
									Vector(1,0,0),
									Vector(0,1,0),
									Vector(0,0,1), 
									(n*3)/10.0f
									+alpha
									);


					}

			 
			  if(flines[i].alpha<1.0f)
				  flines[i].alpha+=0.1f;

			  flines[i].force = Vector(0,0,0);
			  
			  for(int n=0; n<num_charges; n++)
				  charges[n].tick(i, aika);

		}
	
	float kerroin=1.0f;

/*
	for(k=0; k<saw_sync_num; k++)
 		if(originalaika>sawsyncs[k].starttime) {

			if(sawsyncs[k].getVal(originalaika)<1.0f)
		     kerroin+=0.5f*(1-sawsyncs[k].getVal(originalaika));

		}
*/
	cam_pos = sphereCoord((		   (1-calcPosFloat(aika,0,0.15f))*20.0f+
								   (1-calcPosFloat(aika,0,0.45f))*15.0f+
								   1.8f)
								   +saw2beep.getVal(originalaika)*15.0f,	// BEEP SYNC
							aika*4.0f, 
							aika*8.0f);

	for(int l=0; l<num_charges; l++) {
		charges[l].position.x = sin(aika*35)*3+l-5;
		charges[l].position.y = cos(aika*35*l)*1.5f;
	}

	// Lame optimization
	float sin25 = sin(aika*28)*16;

	charges[1].position.y  =  sin25;
	charges[2].position.x  =  sin25;
	charges[2].position.z  =  sin25/4.0f;
	charges[3].position.z  =  sin25;
	charges[4].position.y  =  sin(aika*45)*8;

	float m = 0;
	float y = 0;
	
	if(aika>0.35f) {
		
		bga=calcPosFloat(aika,0.35f,0.4f);

		m = (((float)originalaika/400.0f)+1)*5.0f;
		y = aika*65.0f;
	
		if(aika<0.94f)
		filter.draw_grid(pillars_texture, 
			bga*alpha*0.8f
			, -m, 0, 1.0f, 1.0f, 1.0f, 3.6f, 0);

		filter.draw_grid(box_texture, 
			bga*alpha*1.5f
			, -y, 0, 0.5f, 0.5f, 1.0f, 0.2f, 0 );
	}
} 
