#include "../stuff.hpp"
#include "../matikka.h"
#include "../postproc.hpp"


// 400
const int crashinterval = 400;

extern PostProc filter;

extern int last_beat;

class dot {
	public: 
	float x,y,org_x,org_y,spd_x,spd_y,acc_x,acc_y;
	bool stop, colored;

	dot() {}
	dot(int x,int y) {

		if(x%20==0 || y%20==0 || y==99 || x==99) 
			colored=true;
			else   this->colored=false;

		this->x=(float)x;
		this->org_x=(float)x;
		this->y=(float)y;
		this->org_y=(float)y;
		
		this->spd_x=0.0f;
		this->spd_y=0.0f;
		this->acc_x=0.0f;
		this->acc_y=0.0f;
	}
};
dot *dotlist;
const int count = 10000 ;

float push_position_x;
float push_position_y;
float push_force;
int last_time;
int last_crash;
float scale;
float bg_image_y;
float bgalpha;

const int alku_sync_num=12;
Sync alkusyncs[alku_sync_num] = 
{
	Sync(50000,51000),
	Sync(58000,59000),
	Sync(61500,62500),
	Sync(65000,66000),
	Sync(68500,69500),
	Sync(71800,72800),
	Sync(75300,76300),
	Sync(78700,79700),	// fixed , 13:34
	Sync(82600,83600),
	Sync(86100,87100),
	Sync(89400,91100),
	Sync(93100,94100),
};
const int stop_sync = 11;
const int hold_sync = 9;

int active_sync;
const int look_from[12][3] = 
{
	{-24, -55,40},
	{100,145, 10},
	{75, -75, 10},
	{150, 95, 45},
	{75, -65, 13},
	{-45, 35, 33},
	{15, 145, 36},
	{-39, 30, 45},
	{90, 115, 25},
	{-25,-19, 35},	
	{55,  45, 15}
};

//jos se saa main.cpp:ss jotain vri aikoja tms, kun sdit sit aikaisemmin.. jos siell meni joku pieleen
// en kyl oikein keksi mitaan sielt mika fvois olla vaari
//joo.. kummallinen bugi kyl, ilmaantui ihan yhtkki

//jos vaan surutta ottais hieman vhemmn pisteit, jos toi on niin paljon hitaampi
// itseasias toi sqrt oli nopeempi ku toi flipcoden paske
// uhomasitko miten se kelas ? :D iha hululu vauhtia

//joo, mutta jollain prossulla jossa ei ole nelijuurta raudalla toi on varmaan aika tarpeellinen
// totta, mutta ei ht - tll on tehoja =D

void push(int x, int y, int f) {
 
 if(f==0) return;
 float angle;
 float xd,yd,d;
 unsigned int indx;
 int forc;
 for (indx=0; indx < count; indx++)
 {
	 // Etisyys tynnn keskuksesta
	 xd = x-dotlist[indx].x;
	 yd = y-dotlist[indx].y;

	  d=sqrt((float)(xd*xd+yd*yd));
//	 d = (float) approx_distance( (int)xd, (int)yd );

		angle = (float)(atan2((double)yd , (double)xd));

		if(d>15 && d*d!=0) 
			forc = (int)  ( f/(d*d) );
		  else 
			forc= (int ) ( f/(15*15) );

		dotlist[indx].acc_x-=(float)cos((float)angle)*(forc);
		dotlist[indx].acc_y-=(float)sin((float)angle)*(forc);

		dotlist[indx].x-=(float)cos((float)angle)*(forc);
		dotlist[indx].y-=(float)sin((float)angle)*(forc);
		
 			
		dotlist[indx].stop=false;

 } 	
}

void push(float x, float y, float f) {
	push( (int)x, (int)y, (int)f );
}

void tick() {

int xd, yd;

 unsigned int indx;
  for (indx=0; indx < count; indx++)
  {
 // this dot is moving
 if(dotlist[indx].stop==false) {

	 xd = (int)((dotlist[indx].org_x - dotlist[indx].x)*0.5f);
	 yd = (int)((dotlist[indx].org_y - dotlist[indx].y)*0.5f);

	 dotlist[indx].acc_x+=xd;
	 dotlist[indx].acc_y+=yd;

	 dotlist[indx].spd_x+=dotlist[indx].acc_x;
	 dotlist[indx].spd_y+=dotlist[indx].acc_y;
	
	 dotlist[indx].spd_x-=dotlist[indx].spd_x/1.4f;
	 dotlist[indx].spd_y-=dotlist[indx].spd_y/1.4f;

	 dotlist[indx].acc_x-=dotlist[indx].acc_x/2.5f;
	 dotlist[indx].acc_y-=dotlist[indx].acc_y/2.5f;

	//if(abs(dotlist[indx].spd_x)<1) dotlist[indx].spd_x=0;
	//if(abs(dotlist[indx].spd_y)<1) dotlist[indx].spd_y=0;

	 dotlist[indx].x+=dotlist[indx].spd_x;
	 dotlist[indx].y+=dotlist[indx].spd_y;

	if( 
		//approx_distance( xd, yd )
		sqrt((float)xd*xd+yd*yd)
		< 0.5f && dotlist[indx].spd_x<0.3f && dotlist[indx].spd_y<0.3f) {

	    dotlist[indx].x=dotlist[indx].org_x;
		dotlist[indx].y=dotlist[indx].org_y;
			
		dotlist[indx].stop=true;	// no move calculations anymore
	}

   } // end of if moving


  } 

}

bool alku(float aika, bool beathandled)
{

	glEnable(GL_DEPTH_TEST);
    glEnable(GL_POINT_SMOOTH);
    glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
    glEnable(GL_BLEND);
    glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);

    glPointSize(3.0f);

	   bgalpha = calcPosFloat(aika,0.0f,0.05f)-calcPosFloat(aika,0.93f,0.98f);

		glDisable(GL_DEPTH_TEST);
		glEnable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glBindTexture(GL_TEXTURE_2D, box_texture->ID);
		glColor4f(0.05f*bgalpha,0.05f*bgalpha,0.3f*bgalpha, bgalpha/4.0f );

		glPushMatrix();

		glLoadIdentity();
		perspective2D(1,1);
		
		glRotatef(aika*500,0,0,1);
		billboard(Vector() ,//Vector(calcPosFloat(aika,0.0,0.5)*15-15,bg_image_y,-50), 
				Vector(1,0,0),
				Vector(0,1,0),
				Vector(0,0,1),
				(6-3.5f*calcPosFloat(aika,0,0.3f))*2.0f
				);

		glDisable(GL_TEXTURE_2D);
		perspective3D();
		glPopMatrix();
		glEnable(GL_DEPTH_TEST);


	glLoadIdentity();	// clear matrix

	float del = alkusyncs[active_sync].getVal(originalaika);
	 gluLookAt(		(look_from[active_sync-1][0]-(look_from[active_sync-1][0]-look_from[active_sync][0])*del),
					(look_from[active_sync-1][1]-(look_from[active_sync-1][1]-look_from[active_sync][1])*del),
					(look_from[active_sync-1][2]-(look_from[active_sync-1][2]-look_from[active_sync][2])*del),
					50,50,-50,
					sin(aika*110),cos(aika*120),0);

	 glRotatef(aika*35.0f, 0.1f, 1.0f, -0.3f);

	// SYNCS !!
	float force_kerroin=1.0f;
	float alpha = 0.0f;
	
	for(int k=0; k<alku_sync_num; k++)
	
		if(originalaika>alkusyncs[k].starttime) {
		  alpha+=(1-alkusyncs[k].getVal(originalaika))*0.4f;
		  if(alkusyncs[k].getVal(originalaika)<1.0f)
		   force_kerroin+=2.5f*(1-alkusyncs[k].getVal(originalaika));
		  
		  if(originalaika<alkusyncs[k].endtime) active_sync=k;
		}
	if(aika>0.9f) alpha=0.0f;

	int fc=6000;
	if(last_crash<originalaika-crashinterval) {
		push(randFloat()*80,randFloat()*80,2500*force_kerroin);
		push(randFloat()*80,randFloat()*80,2500*force_kerroin);
		push(randFloat()*80,randFloat()*80,2000*force_kerroin);
		push(randFloat()*80,randFloat()*80,2500*force_kerroin);
		last_crash=originalaika;
	}

	/* 
	// we got a beat - lets dance :)
	if(beathandled==false) {
		push(randFloat()*80,randFloat()*80,1000.0f);
		push(randFloat()*80,randFloat()*80,1000.0f);
	}
	*/

	scale=1;

	// NICE :P ~ not.
	
	if(aika<0.2) {
		push_force=randFloat()*600;
	} else 	if(aika<0.4) {
		push_force=randFloat()*900;
		push_position_x=20+(push_position_x-20)*cos(aika)-(push_position_x-20)*sin(aika);
		push_position_y=20+(push_position_y-20)*sin(aika)+(push_position_y-20)*cos(aika);
	} else if(aika<0.5) {
		push_force = 250; 
		push_position_x=50+(push_position_x-50)*cos(aika*24)-(push_position_x-50)*sin(aika*24);
		push_position_y=50+(push_position_y-50)*sin(aika*24)+(push_position_y-50)*cos(aika*24);
	} else if(aika<0.7) {
//		push(randFloat()*80,randFloat()*80,1500);
		push_force+=15;
		push_position_y-=15*calcPosFloat(aika, 0.5f,0.8f);
		push_position_x+=15*calcPosFloat(aika, 0.5f,0.8f);
	} else if(aika<0.8) {
		//push_position_x-=calcPosFloat(aika,0.8,1.0)*(push_position_x-50);
		//push_position_y-=calcPosFloat(aika,0.8,1.0)*(push_position_y-50);
		push_force=calcPosFloat(aika,0.8f,0.85f)*1500;
		push_position_x=75;
		push_position_y=75;
		push(15,15,400);
	} else if(aika<0.85) {
		push_force=randFloat()*600;
		push_position_x=0;
		push_position_y=0;
	} else if(aika<0.9) {
		push_force = calcPosFloat(aika,0.9f,0.95f)*850;
	} else {
		scale = 1-calcPosFloat(aika, 0.95f, 1);
	}
	
// onneks taa on mukavasti tehty et on helppo debuggaa nait if kiemuroita ':D

    //joo, se on tuttua kyl. if (maaginenluku > jotain) if (rand()%jotainmuuta) teejotain();
// mul on kyl sellanen fiilis et taa voi olla kaantajaski

    // mul oli itel samanlainen juttu jossain vaihees mjut evm miten korjasin :D

    //initialisoimaton muuttuja? tai sitten jotain main.cpp:ss, koska tm on kerran ihan samanlainen
    //kuni toimiva versio.. 
    // vois vilkasta ne muuttujat
    
/// hmmh.. 

    push(push_position_x,push_position_y,push_force);
	
	
	// Ei ajeta fysiikoita realiajasas, vaan 40 framella
	if(originalaika-last_time>25) {

	    if(alkusyncs[stop_sync].getVal(originalaika)==0) 
	     if(alkusyncs[stop_sync-2].getVal(originalaika)==0 
		 || alkusyncs[stop_sync-2].getVal(originalaika)==1 ) 
	   tick();

        last_time = originalaika;
	 }

	float dx, dy;
	int i;

	glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);

	glPointSize(1);
	glBegin(GL_POINTS);
	for(i=0; i<count; i++) {

 	  	  if(dotlist[i].colored)
			glColor4f(0.8f*scale,0.8f*scale,0.8f*scale,scale);
		  else 
		 	glColor4f(0.3f*scale,0.45f*scale,0.9f*scale,scale); 

		  
			dx = dotlist[i].x-dotlist[i].org_x;
			dy = dotlist[i].y-dotlist[i].org_y;

			// SYNC!
			if(aika<0.15f)
				// etsitn paikka
				 glVertex3f(dotlist[i].org_x, dotlist[i].org_y, 				 
				//	 dostlist[i].
				  1.0f*
				  //sqrt((float) dx*dx+dy*dy)
				  approx_distance( (int)dx, (int)dy )
				  //+( -15000+(scale)*(15000))
				  -50);
			else //if(aika<0.6f)
				glVertex3f(dotlist[i].x, dotlist[i].y, 	-50);

	 }
	glEnd();


	// SYNKAT LASKETAAN YLEMPN
	float m = (((float)originalaika/400.0f)+1)*5.0f;
	float y = aika*65.0f;

	filter.draw_grid(pillars_texture, 
		alpha+0.1f
		, m, 0, 1.0f, 1.0f, 1.0f, 0.6f, 1);

	filter.draw_grid(box_texture, 
		alpha+0.1f
		, -y, 0, 0.5f, 0.5f, 1.0f, 0.2f, 0);



	return true;

}

void alku_init()
{


    bgalpha=0;
	last_time=0;
	scale= 0;
	//last_crash=0;
	active_sync=0;

	last_crash=56800;

	push_position_x=50;
	push_position_y=50;
	push_force=500;

	dotlist = new dot[count];

	int i=0;
	for(int x=0; x<100; x++)
		for(int y=0; y<100; y++) {
		dotlist[i] = dot(x,y);
		 i++;
	}

	bg_image_y=0;

}

void alku_free()
{
	delete [] dotlist;
}

 
