#include "hex.h"
#include "../beziercurve.hpp"

#include "../postproc.hpp"

extern PostProc filter;

const int hexoja=150;
const int nelioit=100;

// aika: 130000 - 165500
const int hex_sync_num=6;
Sync hexsyncs[hex_sync_num] = 
{/*
	Sync(135500,136500),	//2:15
	Sync(139000,140000),
	Sync(142500,143500),
	Sync(146000,147000),
	Sync(149500,150500),
	Sync(153000,154500),
	Sync(156500,157500),
	Sync(160000,161000),
	Sync(164000,165000),
	// ei osuta koskaan
	Sync(168000,169000),
	Sync(171000,172000)	// ???
	*/
	Sync(132000,133000),	//2:15
	Sync(142000,143000),
	Sync(150000,151000),
	Sync(153000,154000),
	Sync(164000,165000),
	Sync(167000,168000)
};

// sr synkk - tt vain lopusas
const int hex2_sync_num=9;
Sync hex2syncs[hex2_sync_num] = 
{
	Sync(130000,132000),
	Sync(137500,139000),
	Sync(147000,148000),
	Sync(151500,153000),
	Sync(156500,157500),
	// ei kytss
	Sync(161300,162300),
	Sync(166000,167500),

	Sync(180000,181500),
	Sync(190000,191500)
};


Sync      bigsync(142000,146500);

Sync bigsyncspdup(143500,146500);
Sync  bigsyncslow(142500,144000);
// tdtd
/*
137500		217,5 - 218,5
144500		224,5
151500		231,5
157000		237
165500		245,5
173000		253
180000		300
187000		307
194000		314

// ISO TRANSITIO !?	
144000 - 222 - jatkuu biisi 
*/

class hexa {
public:
	hexa() { kohta=Vector(0,0,0); }
	hexa(Vector k) {
		kohta = k;
		rotate = Vector(randFloat()*2-1.0f,randFloat()-0.5f,randFloat()+0.1f);
	}
	Vector kohta;
	Vector rotate;

	virtual void display(float aika, float kerroin);

};

void hexa::display(float aika , float kerroin) {


	int dir=1;

	float scale;
	float rotatekerroin = 1-(kerroin/6.0f);
	kerroin = 1-rotatekerroin;

	float jump = 0.0f;
	
	if(bigsync.starttime>originalaika) jump+=180;

	kerroin=1-kerroin;
	if(aika<0.3) 
	 scale = calcPosFloat(aika,0.0f,0.3f);
	else 
	 scale = 1-calcPosFloat(aika,0.9f,0.95f);
	
	// if(scale>0.8f) scale=0.8f;
	glScalef(scale,scale,scale);

	//if(aika>0.5) dir=-1;
	glRotatef(aika*350*rotatekerroin+jump,
	//glRotatef(aika*350*rotatekerroin,
			  calcPosFloat((float)aika,0.6f,0.8f),
			  0,
			  1.0f*dir);
	// lhelle mentess lookat kikkailut vois olla poikaa.

		const int offset=2,offset2=2;		

		glBegin(GL_POLYGON);
	
		 glColor4f(0.2f,0.2f*kerroin,0.5f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2,0);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2,0);

		 glColor4f(0.1f,0.1f*kerroin,0.7f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset+3 ,		kohta.y+offset2-1,0);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2-2,0);
		 
		 glColor4f(0.3f,0.3f*kerroin,0.9f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2-2,0);
		 glVertex3f(kohta.x+offset-1,		kohta.y+offset2-1,0);
		
		glEnd();

		glBegin(GL_POLYGON);
	
		 glColor4f(0.4f,0.4f*kerroin,0.6f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2,-0.5);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2,-0.5);
		 
		 glColor4f(0.3f,0.3f*kerroin,0.7f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset+3 ,		kohta.y+offset2-1,-0.5);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2-2,-0.5);

		 glColor4f(0.4f,0.4f*kerroin,0.7f*kerroin,0.5f);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2-2,-0.5);
		 glVertex3f(kohta.x+offset-1,		kohta.y+offset2-1,-0.5);
		
		glEnd();
	
	}

class pala {
public:
	Vector kohta;
	Vector rotate;	
	pala() { kohta=Vector(0,0,0); }
	pala(Vector k) {
		kohta=k;
		rotate = Vector(randFloat()-0.8f,randFloat()-0.3f,randFloat()*2-1.0f);
	}
	virtual void display(float aika, float kerroin);
};

void pala::display(float aika, float kerroin) {

	float scale = 1-calcPosFloat(aika,0.92f,1);
	glScalef(scale,scale,scale);

	glLineWidth(5);
	glMatrixMode(GL_MODELVIEW);
	glRotatef(sin(aika*24)*150 ,rotate.x,rotate.y,rotate.z);
	
		const int offset=2,offset2=2;
		glPolygonMode(GL_FRONT_AND_BACK, GL_LINE); 
	
		//float a = 0.3f;
		
		float a = kerroin;

		glBegin(GL_POLYGON);
	
		 glColor4f(0.2f,0.3f,0.7f,a);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2,0);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2,0);

		 glVertex3f(kohta.x+offset+2+1,		kohta.y+offset2-1,0);

		 glColor4f(0.2f,0.2f,0.6f,a);
		 glVertex3f(kohta.x+offset+2,		kohta.y+offset2-2,0);
		 
		 glColor4f(0.2f,0.3f,0.5f,a);
		 glVertex3f(kohta.x+offset,			kohta.y+offset2-2,0);

		 glVertex3f(kohta.x+offset-1,		kohta.y+offset2-1,0);
		
		 glEnd();
	

		glPolygonMode(GL_FRONT_AND_BACK, GL_FILL); 

}


hexa *list;
pala *lista;

void hexr_init() {
	int i;
	list = new hexa[hexoja];
	lista = new pala[hexoja];

	QuadraticBezierCurve bez(Vector(7,7,8), Vector(0,0,0), Vector(-2,-1,3));

	for(i=0; i<hexoja; i++)  
		list[i]  = hexa(bez.getValue(i*0.01f));
	for(i=0; i<nelioit; i++)  
		lista[i] = pala(Vector(randFloat()*40-20,randFloat()*40-20,0));
	

}
void hexr_free() {
	delete [] list;
	delete [] lista;
}

bool hexr(float aika, bool beat) {
	int i, k;
	
	float kerroin=0.2f;
	float kerroin2=0.0f;

//	z+=(1-bigsync.getVal(originalaika))/15.0f;

	kerroin2 += (bigsync.getVal(originalaika))*0.7f;
//	if(bigsyncslow.endtime > originalaika)
//	 kerroin2 -= bigsyncslow.getVal(originalaika);
	


	// Haetaan synkit
	// Nm on taustasynkat
	for(k=0; k<hex_sync_num; k++)
		if(originalaika>hexsyncs[k].starttime) {
			if(hexsyncs[k].getVal(originalaika)<1.0f)
		     kerroin+=0.3f*(1-hexsyncs[k].getVal(originalaika));
		}

	// Nm on pyrimissynkat
	for(k=0; k<hex2_sync_num; k++)
		if(originalaika>hex2syncs[k].starttime) {
			if(hex2syncs[k].getVal(originalaika)<1.0f)
		     kerroin2+=0.3f*(1-hex2syncs[k].getVal(originalaika));
		}


	// Blendit
	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
	glDisable(GL_TEXTURE_2D);
	glEnable(GL_DEPTH_TEST);

	glLoadIdentity();
	
	glTranslatef(//0
        cos(aika*12)*sin(aika*24)*5.4f,
		cos(aika*22)*sin(aika*33)*6.4f+15-calcPosFloat(aika,0.1f,0.2f)*15, 
		100-calcPosFloat(aika,0,0.1f)*80-calcPosFloat(aika,0.15f,0.2f)*20-25+calcPosFloat(aika,0.8f,0.9f)*15 );

	glPushMatrix();
	for(i=0; i<hexoja; i++) 
		list[i].display(aika, kerroin2);
	glPopMatrix();
	
	
	for(i=0; i<nelioit; i++)  {
		glPushMatrix(); 	
		lista[i].display(aika, kerroin);
		glPopMatrix();
	}

	glDisable(GL_BLEND);

	/*
	float z=0.0f;
	if(originalaika>bigsync.starttime)
		z+=(1-bigsync.getVal(originalaika))/15.0f;

	if(z!=0)
	filter.glow(0.6f, 8, 0.008f, 
				calcPosFloat(aika,0,0.35f)*0.13f+ 
				+z
				-calcPosFloat(aika,0.85f,1.0f)*0.2f, 
				0.9f);
*/

	return true;

} 
