#include "tank.hpp"

// Mahdollisesti viel loppupuolen snareihin jotain

extern PostProc filter;

extern bool beat_handled; 
extern int last_beat;

// SYNCS
const int syncnum = 2;

int last_used_sync;
int drawtype;

const int sync_num=9;
Sync syncs[sync_num] = 
{
Sync(25500,26900),
Sync(29000,30400),
Sync(32500,33900),
Sync(36250,37650),
Sync(39500,40900),
Sync(43000,44400),
Sync(46700,48100),
Sync(50150,51550),
Sync(54000,55400),
};

float last_bash;
const int bashinterval = 900;
float bash_rotations;

class Parti {
public:
	Parti()  { force=Vector(); 
				  position=Vector();
				  pos2=Vector();
				} 
	Vector position;	// position of the base Parti
	Vector force;		// destination of the push
	Vector pos2;
};

class Magnet {
public:
	
	Magnet() { position = Vector();
			   force= 0.0f;
			 }

	Vector position;	// Position of the Parti
	float force;		// force this thing is pushing with

	// move magnets function
	void tick(float aika, int num) {
		if(num<2) {
		 this->position.y=sin(aika*89)*4.0f*(num+1)+cos(aika*34)*4.0f*(num+1);
		 this->position.x=cos(aika*56)*3.0f*(num+1)-sin(aika*56)*3.0f*(num+1);
		} else {
		 this->position.x=sin(aika)*2.0f*num;
		 this->position.y=cos(aika)*1.0f*num;
		}
		if(num==4) {
			this->position.x=sin(aika*36)*1.0f;
			this->position.y=cos(aika*45)*4.0f;
		  }
	}

	void calcEff(Parti &p, float aika) {

		if(this->force!=0) {
		  // Tss tapahtuu magia
		  Vector tmp;
		  tmp = Vector(p.position.x - this->position.x,
					   p.position.y - this->position.y, 0
					   //p.position.z - this->position.z
					   );
					   
		  tmp = tmp.normalize();
		  tmp = tmp*force;	// ajallakertominen ok idea
		  p.force+=tmp;
		}
		
		// TRANSITIO AIKA! ASETA THN SYNC
		p.position=p.position + (p.pos2*4.0f - p.position)*syncs[5].getVal(originalaika);
		p.position=p.position + (p.pos2 - p.position)*syncs[5].getVal(originalaika-1000);


	}
};

Parti *plist;
Magnet *mlist;

extern float bgalpha;

const int magnet_count = 5;
const int partic_count = 10000;




bool tank(float aika, bool dobeat) { 

	int i,n;
	float kerroin;
	

	glLoadIdentity();

    glEnable(GL_BLEND);
	glBlendFunc(GL_ONE, GL_ONE_MINUS_SRC_ALPHA);
	glPointSize(4.0f);

	// Tausta efekti!
	
		bgalpha = calcPosFloat(aika,0.0f,0.05f)-calcPosFloat(aika,0.75f,0.9f);

		glEnable(GL_TEXTURE_2D);
		glDisable(GL_DEPTH_TEST);
		glBindTexture(GL_TEXTURE_2D, circle_texture->ID);
		glColor4f(0.05f*bgalpha,0.05f*bgalpha,0.3f*bgalpha, bgalpha/4.0f );
	
		glPushMatrix();

		// Tt voidaan siirt beateill!
		glLoadIdentity();
		perspective2D(1,1);
		
		glRotatef(aika*350,0,0,1);
		billboard(Vector() ,//Vector(calcPosFloat(aika,0.0,0.5)*15-15,bg_image_y,-50), 
				Vector(1,0,0),
				Vector(0,1,0),
				Vector(0,0,1),
				(8-6*calcPosFloat(aika,0,0.3f))*1.5f	// isona ettei ny reunukset yms.
				);

		glDisable(GL_TEXTURE_2D);
		
		perspective3D();
		glPopMatrix();


	// nice function
	gluLookAt(  cos(aika*65)*8  - calcPosFloat(aika,0.5f,0.8f)*70.0f,	
			 	sin(aika*23)*-7 - calcPosFloat(aika,0.5f,0.8f)*70.0f,	
			    sin(aika*13)*13-(1-aika)*45-calcPosFloat(aika,0.5f,0.8f)*-25.0f,
				calcPosFloat(aika,0.5f,0.8f)*15.0f,calcPosFloat(aika,0.5f,0.8f)*15.0f,0,
				0,1,0);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE);
	glLineWidth(5.0f);

	kerroin=2.0f;
	
	for(int k=0; k<sync_num; k++)
		if(originalaika>syncs[k].starttime) {
		  kerroin+=(1-syncs[k].getVal(originalaika))*3.0f;
	
		  if(originalaika<syncs[k].endtime)
		 	if(last_used_sync<k)
				if(drawtype!=GL_LINES) {
					drawtype=GL_LINES;
					last_used_sync=k;
				} else {
					drawtype=GL_POINTS;	
					last_used_sync=k;
				}
	}

	// Pikkusynkat
	if(last_bash<originalaika-bashinterval) {
		last_bash = originalaika;
		bash_rotations+=1;
	}

	float syncval = (calcPosInt(originalaika, last_bash, last_bash+300))*0.4f;


	// Liikutetaan magneetteja
	for(i=0; i<magnet_count; i++)
		mlist[i].tick(aika,i);


		glPushMatrix();

		if(aika<0.1f) 
			glTranslatef((1-calcPosFloat(aika,0,0.1f))*10.0f,0,(1-calcPosFloat(aika,0,0.1f))*-65.0f);
		
		glRotatef((0.5f-aika)*1720,-0.1f,-0.3f,0.6f);
		if(originalaika>syncs[4].starttime) {
			glRotatef((0.5f-aika)*1720*(kerroin/-5.0f),-0.1f,-0.3f,0.6f);
			//if(kerroin==2)	// tll siirrell pikkusynkkei
			 glRotatef(bash_rotations*15.0f*syncval
				 , 0,-1,0);
		}
		// Kerroin pois jos kakssuuntaa ei oo ok :)

		glBegin(drawtype);
			for(i=0; i<partic_count; i++) {
				
				// Reset force
				plist[i].force=Vector(0,0,0);
			
				// Calculate forces
				for(n=0; n<magnet_count; n++)
					 mlist[n].calcEff(plist[i],aika);
				
					// Add vertexes and colors
					glColor4f(0.3f,0.3f,0.9f-(0.8f*syncval),0.3f);
					glVertex3fv((float *)&(plist[i].position));
					glColor4f(0.3f,0.4f,0.9f-(0.8f*syncval),0.3f);	
					glVertex3fv((float *)&(plist[i].position+plist[i].force.normalize()*kerroin));
			}

		glEnd();

/*
	float m = (((float)originalaika/400.0f)+1)*5.0f;
	
	if(alpha>0)
	 filter.draw_grid(pillars_texture, 
		alpha
		, m, 0, 1.0f, 1.0f, 1.0f, 3.5f, 1);
		*/

/*		// Identifierit 'kohdille'
		glBegin(GL_POINTS);
				for(n=0; n<magnet_count; n++)
					glVertex3fv((float *)(&mlist[n].position));
		glEnd();
*/

		glPopMatrix();


return true;
	
}


void tank_init() { 

	last_bash= 43000 - bashinterval;
	bash_rotations = 0;

	int i;
	
	mlist = new Magnet[magnet_count];     

	mlist[0].position = Vector(-30,-30,-0.1f);
	mlist[1].position = Vector(10,30,-0.1f);
	mlist[2].position = Vector(40,10,-0.1f);
	mlist[3].position = Vector(40,30,-0.1f);


	mlist[0].force=10.7f;
	mlist[1].force=16.7f;
	mlist[2].force=14.0f;
	mlist[3].force=8.0f;
	mlist[4].force=-13.0f;

	plist = new Parti[10000]; 

	last_used_sync=0;
	drawtype=GL_LINES;

	int points = 4;
	int lasti = 0;


	for(i=0; i<partic_count; i++) {
		plist[i].position = Vector((i%100-50)*0.3f,(i/100.0f-50)*0.3f,0.0f);
		if(i+lasti>=points) {

			points=points+10;
			lasti=i;
		}
 
		plist[i].pos2.x=(randFloat()-0.5f)*60;
		plist[i].pos2.y=(randFloat()-0.5f)*60;
		plist[i].pos2.z=(randFloat()-0.5f)*60;

	}
}

void tank_free() { 
	delete [] plist;
	delete [] mlist;
}
 
