// Tunneliefekti
#include "tunnel.hpp"
#include "../beziercurve.hpp"

QuadraticBezierCurve tunnel_orientation(Vector(0,0,0), Vector(-350,450,1200), Vector(10,-10,3500));

class point {
public:
	point() {
		position = Vector();
		velocity = Vector();
	}
	Vector position;
	Vector velocity;
	void tick(float aika) {
		this->position+=this->velocity;
	}
};

point *polist;

int ptscount = 100;


void tunnel(float aika) { 

	int i;

	// Reset the projection matrix stack
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
 
	// lookfrom, lookat, head
	 gluLookAt(25, 25, 50, 
					0,0,-1500, 
					0, 1,0);
	glDisable(GL_TEXTURE_2D);

	Vector testp;

	glPushMatrix();
	glTranslatef(20,20,0);
	glBegin(GL_POINTS);
	for(i=0; i<50; i++) 
		
		glVertex3f( 28*(float)(sin(i*0.0628f)*cos(i*0.0628f)),
					28*(float)(sin(i*0.0628f)*sin(i*0.0628f)),
					0);

	glEnd();
	glPopMatrix();
	
}

void tunnel_init() {
	int i;

	polist = new point[ptscount];

	for(i=0; i<ptscount; i++) {
		polist[i].position.x=4*sin((float)i);
		polist[i].position.y=4*cos((float)i);
		polist[i].position.z=0;
		polist[i].velocity.x=randFloat()*1.0f;
		polist[i].velocity.y=randFloat()*1.0f;
		polist[i].velocity.z=0;
	}
}

void tunnel_free() {
	delete [] polist;
}
 
