#include "vertex1.hpp"
#include "../beziercurve.hpp"

#include "../ParticleEngine.h"

Vector *v;
extern ParticleEngine pe;


const int p2x = 120;
const int p2y = 95;
const int p3x = 95;
const int p3y = 350;

const int draw_pillars = 5;
const int pillars_x_pos = 15;
const int pillars_rotate_angle = 12;

Vector *pillars;

CubicBezierCurve m = CubicBezierCurve(
	Vector(100,-10,0),
	Vector((float)p2x,(float)p2y,0),
	Vector((float)p3x,(float)p3y,0),
	Vector(-10,250,0)
);
float last_t;
void ver_init() {

	v = new Vector[350];
	for(int i=0; i<350; i++) 
		v[i] = Vector(randFloat()*(OPENGL_XRES+60)-30,randFloat()*(OPENGL_YRES+60),-30);

 pillars = new Vector[20];
 last_t=0;
}

void ver_free() {
	delete [] pillars;
	delete [] v;
	pe.free();
}

void ver(float aika)
{

	if(aika > last_t+0.001f) {
		last_t=aika;
		pe.addEffect(randFloat()*40.0f,
					 randFloat()*40.0f,
					 randFloat ()*15.0f-15.0f,
					 150);
	}

		gluLookAt( 0, 0, 75 ,
				   0, 3,-10,
				   0, 1,  0); 
		
		//glColor3f(0.4f,0.2f,0.7f);
		glColor3f(1,1,1);

		pe.draw();



/*	}


	glLoadIdentity();
	glPushMatrix();

	perspective2D(OPENGL_XRES,OPENGL_YRES);

	glEnable(GL_BLEND);
	glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);


	glColor4f(0.2f,0.3f,0.3f,0.2f);
	glBegin(GL_LINE_STRIP);
	for(int i=0; i<350; i++) {
		if(i%2==0)	v[i].x+=cos(aika*24);
		else v[i].y-=sin(aika*24);
		glVertex3fv((float *)(&v[i]));
	}
	glEnd();
	
	perspective3D();*/


} 
