// EI toimi VS7.1net
//#pragma comment(linker, "/OPT:NOWIN98" )
//#pragma comment(linker,"/FILEALIGN:0x200") 

// comment out!
#define RUNDEMO

//mist se ottaa synkkiarvon? playerista vai ihan vaan ajan perusteella?



#define WIN32_LEAN_AND_MEAN
#define WIN32_LEANER_AND_MEANER

#include "misc.hpp"
#include "win32.hpp"
#include "texture.hpp"
#include "font.hpp"
#include "config.hpp"
#include "stuff.hpp"

#include "timer.hpp"

#include "sound.hpp"

#include "postproc.hpp"
#include "ParticleEngine.h"

//#include "stdio.h"	// FOR SPRINTF

#include "Effects/alku.hpp"
#include "Effects/tank.hpp"
#include "Effects/ltree.hpp" 
#include "Effects/hex.h"
#include "Effects/load.h"
#include "Effects/sawart.h"
#include "Effects/transition.h"	
#include "Effects/end.h"

//#include "effects/ranta.hpp"

//#include "effects/tunnel.hpp"
//#include "effects/vertex1.hpp"


//#include "effects/pillars.hpp"

Texture *render512_0;
Texture *render512_1;
Texture *box_texture;
Texture *circle_texture;
Texture *circle2_texture;
Texture *circle3_texture;
Texture *pillars_texture;
Texture *particle_texture;

Window win;
int OPENGL_XRES;
int OPENGL_YRES;
bool OPENGL_FULLSCREEN;

Vector clearcolor;
int originalaika;	//globaali, ett nkyisi muuallekin.. 

Sound sound;
PostProc filter;
ParticleEngine pe;
Timer kello;

bool runflag=false;
bool musicflag=true;
bool spookyflag=false;

int last_beat=0;
bool beat_handled=false;

/*#ifdef _DEBUG
	int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE prevInstance, LPSTR cmd, int n)
#else
	int WINAPI WinMain(HINSTANCE hInstance, HINSTANCE prevInstance, LPSTR cmd, int n)
	
#endif*/
int main(int argc, char **argv)
{
	//MSG msg = {0};
	bool done = false;

	//bring up the dialog	
	/*if(DialogBox(hInstance, MAKEINTRESOURCE(IDD_SETUPDIALOG), NULL, (DLGPROC)ConfigProc) == 1)
	{
		return false;
	}*/

//	musicflag=false;
//	OPENGL_FULLSCREEN=false;
	/*	runflag=true;
	OPENGL_XRES=640;
	OPENGL_YRES=480;
*/

 
	//if we want to run the intro
	if (runflag==true)
	{
		//create window and sound if necessary
		if(!win.create(false)) return 0;

		if (musicflag==true)
		{
			if(!sound.init()) 
				return 0;
		}

		//**************ENGINEN INITIT THN********************
		
		textures_init();
		font_init();

		//***************EFEKTIEN INITIT THN******************

		loadr_init();
		alku_init();	
		tank_init();
		ltree_init();
		hexr_init();
		saw_init();
		//end_init();
		//ranta_init();
		//ver_init();
		//tunnel_init();
		//pillars_init();
		

		clearcolor = Vector(0,0,0.0);

		if (musicflag==true)
			sound.play();

		kello.start();
		SDL_Event event;
		while(!done)
		{

				
                        SDL_PollEvent(&event);
                        switch(event.type)
                        {
                                case SDL_QUIT:
                                        done = true;
                                        break;
                                case SDL_KEYDOWN:
                                        switch (event.key.keysym.sym)
                                        {
                                                case SDLK_ESCAPE:
                                                        done = true;
                                                        break;
                                        }
                        }

			/*if(PeekMessage(&msg, NULL, 0, 0, PM_REMOVE))
			{
				if(msg.message == WM_QUIT)
				{
					done = true;
				}
				else
				{
					TranslateMessage(&msg);
					DispatchMessage(&msg);
				}
			}
			else*/
			{
				glEnable(GL_POINT_SMOOTH);
				glHint(GL_POINT_SMOOTH_HINT, GL_NICEST);
				glEnable(GL_LINE_SMOOTH);
				glHint(GL_LINE_SMOOTH_HINT, GL_NICEST);
				glPointSize(3.0f);

				glClearColor(clearcolor.x , clearcolor.y, clearcolor.z, 1);
				glDepthMask(1);
				
				// Clear color and depth buffers
				glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
				
				// Reset the viewport back to original
				glViewport(0, 0, OPENGL_XRES, OPENGL_YRES);



/*
				if (GetAsyncKeyState(VK_RIGHT))
					kello.add(0.05f*5);
				if (GetAsyncKeyState(VK_LEFT))
					kello.add(-0.05f*5);

				if (GetAsyncKeyState(VK_UP))
					kello.add(0.05f*15);
				if (GetAsyncKeyState(VK_DOWN))
					kello.add(-0.05f*15);

  // oiskoha toho viel jotain listtv? t
  //tuskinpa, mun mielest se nytt mainiolta nyt. Pannaako pakettiin ja kompoon? Voispa pistaa
    */

				// Reset projection matrix at the beginning of each frame
				glMatrixMode(GL_PROJECTION);
				glLoadIdentity();
	
				// Set the camera settings
				// fieldofview, kuvasuhde, lhi ja kaukotaso
				// gluPerspective(60.0f, 1024.0f/768.0f, 0.5f, 14000.0f);
				gluPerspective(60.0f, OPENGL_XRES/(float)OPENGL_YRES, 0.5f, 14000.0f);

 				// Reset the model matrix stack
				glMatrixMode(GL_MODELVIEW);
				glLoadIdentity();

				glDisable(GL_TEXTURE_2D); 

				kello.update();
				//originalaika = GetTickCount()-alkuaika;	// t on original
				originalaika = (int)kello.getMilliseconds();

#ifndef RUNDEMO

//				char text[50] = "";
//				sprintf( text, "time %d", originalaika);
					
				const int alkuajat[] = {0, 41500};

				const int introloppu = 52000;
		
				glViewport(0, 0, OPENGL_XRES, OPENGL_YRES);

				glLoadIdentity();
/*				glDisable(GL_TEXTURE_2D); 
				glDisable(GL_DEPTH_TEST);
				glTranslatef(0, 0, 0.0f);
				glColor4f(1,1,1,1);
				font_write3d(text); 
*/
				if(originalaika - last_beat > 410) {
					last_beat=originalaika;
					beat_handled=false;
				}
	
				if (testaaPos(originalaika, alkuajat)) 
					alku(laskePos(originalaika, alkuajat),0);
					//hexr(laskePos(originalaika, alkuajat),beat_handled);
				

				beat_handled=true; 
/*
				glDisable(GL_TEXTURE_2D);
				glDisable(GL_DEPTH_TEST);
				glEnable(GL_BLEND);
				glBlendFunc(GL_SRC_COLOR,GL_ONE);
				char tex[50] = "";
				sprintf( tex, "time %i", originalaika);
				glLoadIdentity(); 
				
				glColor4f(0.7f,0.2f,0.3f,1.0f);
				glTranslatef(0,0,-1);
				//glRotatef(originalaika/24.0f, 0,1,1);
				font_write(-0.7f,-0.55f,tex); 
*/
#else 

				if(originalaika - last_beat > 410) {
					last_beat=originalaika;
					beat_handled=false;	
				}

				const int alkuajat[]  = {0,			11000};
				const int alkupullo[] = {10500,		25500};		// pulloon sukellus
				const int alkuajat1[] = {23500,		57000};		// magneettikentt
				const int alkuajat2[] = {57000,		95500};		// alku
				const int alkuajat3[] = {95500,		136500};	// biot savart
				const int alkuajat4[] = {130000,	165500};	// hexr = spiraali
				const int alkuajat5[] = {165500,	205000};	// savart 2 random setit	
				const int alkuajat6[] = {200000,	208000};	// viimenen skene - mid turns
																// pulloskene
				const int alkuajat7[] = {207000,	220000};	// viimenen skene - fade out after turn 2

				const int transajat[] = {55500,		57500};		// knnstransitio
				const int transajat2[]= {200000,	201000};	// knnstransitio 
				const int transajat3[]= {207000,	208000};	// knnstransitio
	
				const int introloppu = 220000;

				glViewport(0,0,512,512);

				if (testaaPos(originalaika, alkuajat))				
					loadr(laskePos(originalaika, alkuajat));
					//ranta(laskePos(originalaika, alkuajat), last_beat);
					
				if (testaaPos(originalaika, alkupullo))				
					loadr2(laskePos(originalaika, alkupullo));
				
				if (testaaPos(originalaika, alkuajat1))				
					tank(laskePos(originalaika, alkuajat1), beat_handled);
				
				// Transitio!!
				if (testaaPos(originalaika, transajat)) {
				
					// render fx1
					//glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
					//ltree(laskePos(originalaika, alkuajat1), beat_handled);
					//tank(laskePos(originalaika, alkuajat1), beat_handled);
					texture_buffer(render512_0);

					// render fx2
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
					alku(laskePos(originalaika, alkuajat2), beat_handled);
					texture_buffer(render512_1);
					
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

					// render transition
					trans(laskePos(originalaika, transajat), render512_0, render512_1);
				} else  
				if (testaaPos(originalaika, alkuajat2)) 
					alku(laskePos(originalaika, alkuajat2), beat_handled);
				
				if (testaaPos(originalaika, alkuajat3))
					saw(laskePos(originalaika, alkuajat3));

				if (testaaPos(originalaika, alkuajat4))
					hexr(laskePos(originalaika, alkuajat4), beat_handled);

				// Transitio loppupyrhdys
				if (testaaPos(originalaika, transajat2)) {
				
					if(testaaPos(originalaika, alkuajat5))
					//ltree(laskePos(originalaika, alkuajat5), beat_handled);
					 saw2(laskePos(originalaika, alkuajat5));

					// otetaan vanha bufferista
					texture_buffer(render512_0);

					// renderidn knnksen kohde
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
					// end(laskePos(originalaika, alkuajat6));
					ltree(laskePos(originalaika, alkuajat6),beat_handled);

					texture_buffer(render512_1);
					
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

					// render transition
					trans(laskePos(originalaika, transajat2), render512_0, render512_1);
				} else  
				// Transitio loppupyrhdys2
				if (testaaPos(originalaika, transajat3)) {
				
					if(testaaPos(originalaika, alkuajat6))
					 //end(laskePos(originalaika, alkuajat6));
					 ltree(laskePos(originalaika, alkuajat6),beat_handled);

					// otetaan vanha bufferista
					texture_buffer(render512_0);

					// renderidn knnksen kohde
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);
					end(laskePos(originalaika, alkuajat7));
					texture_buffer(render512_1);
					
					glClear(GL_DEPTH_BUFFER_BIT | GL_COLOR_BUFFER_BIT);

					// render transition
					trans(laskePos(originalaika, transajat3), render512_0, render512_1);
				} else  
				 if(testaaPos(originalaika, alkuajat7)) 
					end(laskePos(originalaika, alkuajat7));
				else 
				 if(testaaPos(originalaika, alkuajat6)) 
					ltree(laskePos(originalaika, alkuajat6),beat_handled);
				else 
				 if(testaaPos(originalaika, alkuajat5))
					//ltree(laskePos(originalaika, alkuajat5), beat_handled);
					saw2(laskePos(originalaika, alkuajat5));




				// okay enough with this beat :)
				beat_handled = true;
				
				// Renderidn kokosetti takas
				glViewport(0, 0, OPENGL_XRES, OPENGL_YRES);
				texture_buffer(render512_0);
				float boxfade=1.0f;
				bool tex_wall=false;	// teksturoidaanko seint
				if(originalaika>alkuajat3[1]) {
					tex_wall=true;
				}

				// scale, t1,t2, angle, fade, box or no, texturewalls, boxfade
				
				trans_help(
					// drawscale
					1-
					0.2f*(calcPosInt(originalaika,alkupullo[1],alkupullo[1]+7000))
					-(calcPosInt(originalaika,alkuajat4[0],alkuajat4[0]+10000)*0.2f)
					+(calcPosInt(originalaika,alkuajat4[1]-5000,alkuajat4[1]-2500)*0.2f)	// sisn ja ulosajo
					,				
					render512_0, 
							//box_texture,	// texture1
					NULL,  // texture2
					0,		// angle of turning
					calcPosInt(originalaika,alkuajat2[1],alkuajat2[1]+2000)
					-calcPosInt(originalaika,alkuajat3[1]-2000,alkuajat3[1]),	// fade factor for center rect
					true,														// box (else - textured borders)
					tex_wall,													// texture walls (false - draw lines)
					calcPosInt(originalaika,alkuajat3[1]+1500,alkuajat3[1]+6500)		// fade textures
					-(calcPosInt(originalaika,alkuajat4[1]-13000,alkuajat4[1]-10000) )
					);

/*				glDisable(GL_TEXTURE_2D);
				glDisable(GL_DEPTH_TEST);
				glEnable(GL_BLEND);
				glBlendFunc(GL_SRC_COLOR,GL_ONE);
				char tex[50] = "";
				sprintf( tex, "time %i", originalaika);
				glLoadIdentity(); 
				
				glColor4f(0.7f,0.2f,0.3f,1.0f);
				glTranslatef(0,0,-1);
				font_write(-0.7f,-0.55f,tex); 
*/

#endif  

				//SwapBuffers(win.getDC());
				SDL_GL_SwapBuffers();

				if (originalaika >= introloppu)
					done = true;

			}
		}

		//call each effect's release function
		saw_free();
		tank_free();
		alku_free();
		ltree_free();
		hexr_free();
		loadr_free();
		//end_free();
		//		ver_free();
		//ranta_free();
		//		tunnel_free();
		//		pillars_free();
		

		//free engine related things
		pe.free();
		textures_free();
		font_free();

		if (musicflag==true) 
			sound.release(); 

		//... and that was it, then.
		SDL_Quit();
		return 0;	
	}
	else //we don't want to run the intro.. bummer
	{
		return 0;
	}

}
 
